SystemOrganization addCategory: #'Tropo-Core'!

Object subclass: #TPJsonObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

TPJsonObject subclass: #TPAsk
	instanceVariableNames: 'choices attempts bargein minConfidence name recognizer required say timeout voice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPAsk commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/ask.htm

TPAsk has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	choices	<ProtoObject | PseudoContext>
	attempts	<ProtoObject | PseudoContext>
	bargein	<ProtoObject | PseudoContext>
	minConfidence	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	recognizer	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	say	<ProtoObject | PseudoContext>
	timeout	<ProtoObject | PseudoContext>
	voice	<ProtoObject | PseudoContext>!

!TPAsk methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:43'!
method
	^'ask'! !

TPJsonObject subclass: #TPCall
	instanceVariableNames: 'to answerOnMedia channel from headers name network recording required timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPCall commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/call.htm

TPCall has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	to	<ProtoObject | PseudoContext>
	answerOnMedia	<ProtoObject | PseudoContext>
	channel	<ProtoObject | PseudoContext>
	from	<ProtoObject | PseudoContext>
	headers	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	network	<ProtoObject | PseudoContext>
	recording	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	timeout	<ProtoObject | PseudoContext>!

!TPCall methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:43'!
method
	^'call'! !

TPJsonObject subclass: #TPConference
	instanceVariableNames: 'id mute name playTones required terminator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPConference commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/conference.htm

TPConference has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	id	<ProtoObject | PseudoContext>
	mute	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	playTones	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	terminator	<ProtoObject | PseudoContext>!

!TPConference methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:42'!
method
	^'conference'! !

TPJsonObject subclass: #TPHangup
	instanceVariableNames: 'headers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPHangup commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/hangup.htm

TPHangup has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	headers	<ProtoObject | PseudoContext>!

!TPHangup methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:42'!
method
	^'hangup'! !

!TPJsonObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:49'!
jsonOn: aStream
	| x y vars |
	 vars:=self allInstVarNames.
	
	x := Dictionary new.
	y := Dictionary new.
	
	vars
		do: [ :each | 
			(self perform: each asSymbol) isNil
				ifFalse: [ 
					 x at: each put: (self perform: each asSymbol) ] ] .
			
	y at: self method put: x.
	
	y jsonOn: aStream! !

TPJsonObject subclass: #TPMessage
	instanceVariableNames: 'say to answerOnMedia channel from name network required timeout voice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPMessage commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/message.htm

TPMessage has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	say	<ProtoObject | PseudoContext>
	to	<ProtoObject | PseudoContext>
	answerOnMedia	<ProtoObject | PseudoContext>
	channel	<ProtoObject | PseudoContext>
	from	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	network	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	timeout	<ProtoObject | PseudoContext>
	voice	<ProtoObject | PseudoContext>!

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
answerOnMedia
	^ answerOnMedia! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
answerOnMedia: anObject
	answerOnMedia := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
channel
	^ channel! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
channel: anObject
	channel := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
from
	^ from! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
from: anObject
	from := anObject! !

!TPMessage methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:42'!
method
	^'message'! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
name
	^ name! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
name: anObject
	name := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
network
	^ network! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
network: anObject
	network := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
required
	^ required! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
required: anObject
	required := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
say
	^ say! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
say: anObject
	say := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
timeout
	^ timeout! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
timeout: anObject
	timeout := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
to
	^ to! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
to: anObject
	to := anObject! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
voice
	^ voice! !

!TPMessage methodsFor: 'accessing' stamp: 'PaulDeBruicker 12/14/2010 17:24'!
voice: anObject
	voice := anObject! !

TPJsonObject subclass: #TPOn
	instanceVariableNames: 'event name next required say'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPOn commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/on.htm
TPOn has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	event	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	next	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	say	<ProtoObject | PseudoContext>!

!TPOn methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:42'!
method
	^'on'! !

TPJsonObject subclass: #TPRecord
	instanceVariableNames: 'attempts bargein beep choices format maxSilence maxTime method minConfidence name required say transcription url password username timeout voice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPRecord commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/record.htm

TPRecord has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	attempts	<ProtoObject | PseudoContext>
	bargein	<ProtoObject | PseudoContext>
	beep	<ProtoObject | PseudoContext>
	choices	<ProtoObject | PseudoContext>
	format	<ProtoObject | PseudoContext>
	maxSilence	<ProtoObject | PseudoContext>
	maxTime	<ProtoObject | PseudoContext>
	method	<ProtoObject | PseudoContext>
	minConfidence	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	say	<ProtoObject | PseudoContext>
	transcription	<ProtoObject | PseudoContext>
	url	<ProtoObject | PseudoContext>
	password	<ProtoObject | PseudoContext>
	username	<ProtoObject | PseudoContext>
	timeout	<ProtoObject | PseudoContext>
	voice	<ProtoObject | PseudoContext>!

!TPRecord methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:42'!
method
	^'record'! !

TPJsonObject subclass: #TPRedirect
	instanceVariableNames: 'to name required'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPRedirect commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/redirect.htm

TPRedirect has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	to	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>!

!TPRedirect methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:41'!
method
	^'redirect'! !

TPJsonObject subclass: #TPReject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPReject commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/reject.htm

TPReject has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.!

!TPReject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:41'!
method
	^'reject'! !

TPJsonObject subclass: #TPResult
	instanceVariableNames: 'actions complete error sequence sessionDuration sessionId state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPResult commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/result.htm

TPResult has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	actions	<ProtoObject | PseudoContext>
	complete	<ProtoObject | PseudoContext>
	error	<ProtoObject | PseudoContext>
	sequence	<ProtoObject | PseudoContext>
	sessionDuration	<ProtoObject | PseudoContext>
	sessionId	<ProtoObject | PseudoContext>
	state	<ProtoObject | PseudoContext>!

!TPResult methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:41'!
method
	^'result'! !

TPJsonObject subclass: #TPSay
	instanceVariableNames: 'value as name voice required'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPSay commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/say.htm

TPSay has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	value	<ProtoObject | PseudoContext>
	as	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	voice	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>!

!TPSay methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:41'!
method
	^'say'! !

TPJsonObject subclass: #TPSession
	instanceVariableNames: 'accountId callId form headers id initialText parameters timestamp to userType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPSession commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/session.htm

TPSession has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	accountId	<ProtoObject | PseudoContext>
	callId	<ProtoObject | PseudoContext>
	form	<ProtoObject | PseudoContext>
	headers	<ProtoObject | PseudoContext>
	id	<ProtoObject | PseudoContext>
	initialText	<ProtoObject | PseudoContext>
	parameters	<ProtoObject | PseudoContext>
	timestamp	<ProtoObject | PseudoContext>
	to	<ProtoObject | PseudoContext>
	userType	<ProtoObject | PseudoContext>!

!TPSession methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:40'!
method
	^'session'! !

TPJsonObject subclass: #TPStartRecording
	instanceVariableNames: 'format method url username password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPStartRecording commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/startrecording.htm

TPStartRecording has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	format	<ProtoObject | PseudoContext>
	method	<ProtoObject | PseudoContext>
	url	<ProtoObject | PseudoContext>
	username	<ProtoObject | PseudoContext>
	password	<ProtoObject | PseudoContext>!

!TPStartRecording methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:39'!
method
	^'startRecording'! !

TPJsonObject subclass: #TPStopRecording
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPStopRecording commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/stoprecording.htm
TPStopRecording has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.!

!TPStopRecording methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:39'!
method
	^'stopRecording'! !

TPJsonObject subclass: #TPTransfer
	instanceVariableNames: 'to answerOnMedia choices from headers name on required ringRepeat terminator timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPTransfer commentStamp: '<historical>' prior: 0!
https://www.tropo.com/docs/webapi/transfer.htm

TPTransfer has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	to	<ProtoObject | PseudoContext>
	answerOnMedia	<ProtoObject | PseudoContext>
	choices	<ProtoObject | PseudoContext>
	from	<ProtoObject | PseudoContext>
	headers	<ProtoObject | PseudoContext>
	name	<ProtoObject | PseudoContext>
	on	<ProtoObject | PseudoContext>
	required	<ProtoObject | PseudoContext>
	ringRepeat	<ProtoObject | PseudoContext>
	terminator	<ProtoObject | PseudoContext>
	timeout	<ProtoObject | PseudoContext>!

!TPTransfer methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 16:39'!
method
	^'transfer'! !

Object subclass: #TPSendSms
	instanceVariableNames: 'message token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tropo-Core'!

!TPSendSms commentStamp: '<historical>' prior: 0!
You can send sms to numbers in the USA .  

See here: http://blog.tropo.com/2010/11/19/simple-post-and-get-interface-to-tropo-sms/

After registering at tropo.com create a new Tropo Scripting application that uses the simpleMessage.php script found on their github.


Then you can use TPSendSms class>>to:withMessage: to send an SMS.  You need to set a voice/sms number on tropo and also change the token on the class side of TPSendSms. 

Uses HTTPSocket.  !

!TPSendSms classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 17:51'!
apiVersion
	^'1.0'! !

!TPSendSms classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 12:20'!
to: aPhoneNumber withMessage: aString
	^self new sendSms: aString to: aPhoneNumber ! !

!TPSendSms classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/27/2010 16:38'!
tropoToken 
	"you get this afer registering at tropo.com"
	^''! !

!TPSendSms methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 11:59'!
initialize 


super initialize .
message :=OrderedCollection new.! !

!TPSendSms methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/16/2010 14:16'!
sendSms: aString to: aPhoneNumber
|responses|
	aString size > 160
		ifTrue: [ self splitInto160CharacterSegments: aString ]
		ifFalse: [ message add: aString ].

responses :=OrderedCollection new.

	message
		do: [ :each | 
		responses add:(HTTPSocket
				httpGetDocument: self tropoUrl
				args: (self smsArgsWith: each to: aPhoneNumber)) ].
	^responses! !

!TPSendSms methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 17:49'!
smsArgsWith: a160CharacterLongString to: aPhoneNumber

	|x|
	x:=Dictionary new.
	x at: 'action' put: 'create'.
	x at: 'token' put: self class tropoToken.
	x at: 'to' put: aPhoneNumber.
	x at: 'msg' put: a160CharacterLongString.
	x at: 'network' put:'SMS'.
	^x
	! !

!TPSendSms methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 12:01'!
splitInto160CharacterSegments: aString
	aString size > 160
		ifFalse: [ ^ message add: aString ]
		ifTrue: [ 
				message	add: (aString copyFrom: 1 to:  160).
				self splitInto160CharacterSegments: (aString copyFrom: 161 to: aString size) ]
			
		! !

!TPSendSms methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2010 15:45'!
tropoUrl 

		^'http://api.tropo.com/', self class apiVersion , '/sessions'! !
